diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelVeryRotatable.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelVeryRotatable.java
index 470553f46..c4b82c4ff 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelVeryRotatable.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelVeryRotatable.java
@@ -64,9 +64,9 @@ public class BlockModelVeryRotatable<T extends BlockLogic> extends BlockModelSta
         final Direction dir = BlockLogicVeryRotatable.metaToDirection(data);
         return switch (dir) { // I love brute forcing fixes so much :3
             case SOUTH -> side;
-            case EAST -> side.getDirection().rotate(1).getSide();
-            case NORTH -> side.getDirection().rotate(2).getSide();
-            case WEST -> side.getDirection().rotate(3).getSide();
+            case EAST -> side.direction().rotateY(3).side();
+            case NORTH -> side.direction().rotateY(2).side();
+            case WEST -> side.direction().rotateY(1).side();
             case UP -> switch (side) {
                 case NORTH -> Side.TOP;
                 case SOUTH -> Side.BOTTOM;
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/RenderBlocks.java b/game/client/src/main/java/net/minecraft/client/render/block/model/RenderBlocks.java
index 81a98d504..01ec287f8 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/RenderBlocks.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/RenderBlocks.java
@@ -91,9 +91,9 @@ public final class RenderBlocks {
 
     public void setRenderSide(@NotNull Side side, boolean shouldRender) {
         if (!shouldRender) {
-            this.renderBitMask |= (byte) (1 << side.getId());
+            this.renderBitMask |= (byte) (1 << side.id);
         } else {
-            this.renderBitMask &= (byte) ~(1 << side.getId());
+            this.renderBitMask &= (byte) ~(1 << side.id);
         }
     }
 
@@ -212,7 +212,7 @@ public final class RenderBlocks {
                               int lefX, int lefY, int lefZ, float lefP, float rigP
     ) {
         IconCoordinate tex = blockModel.getBlockTexture(worldSource, tilePos, side);
-        if (tex == null || ((this.renderBitMask >> side.getId()) & 1) != 0) return false;
+        if (tex == null || ((this.renderBitMask >> side.id) & 1) != 0) return false;
 
         boolean rendered = false;
         if (this.renderAllFaces || blockModel.shouldSideBeRendered(worldSource, bounds, tilePos.add(dirX, dirY, dirZ, new TilePos()), side, meta)) {
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericPiston.java b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericPiston.java
index df0372f54..cd622adc5 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericPiston.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericPiston.java
@@ -4,7 +4,7 @@ import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.block.BlockLogicVeryRotatable;
-import net.minecraft.core.block.piston.BlockLogicPistonBase;
+import net.minecraft.core.block.piston.PistonCommon;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.pos.TilePos;
@@ -46,8 +46,8 @@ public class BlockModelGenericPiston<T extends BlockLogic> extends BlockModelGen
 
     @Override
     public @NotNull StaticBlockModel getModelFromData(int data) {
-        boolean extended = /*noCulling || */(data & BlockLogicPistonBase.MASK_POWERED) != 0;
-//        Direction direction = BlockLogicPistonBase.getDirection(meta);
-        return extended ? this.extended : super.getModelFromData(data);
+        return (/*noCulling || */PistonCommon.IS_DETACHED_OR_EXTENDED.bool(data)) 
+            ? this.extended 
+            : super.getModelFromData(data);
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericPistonHead.java b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericPistonHead.java
index 21092070a..4373c7aa8 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericPistonHead.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericPistonHead.java
@@ -3,9 +3,7 @@ package net.minecraft.client.render.block.model.generic;
 import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogic;
-import net.minecraft.core.block.BlockLogicVeryRotatable;
-import net.minecraft.core.block.piston.BlockLogicPistonBase;
-import net.minecraft.core.block.piston.BlockLogicPistonHead;
+import net.minecraft.core.block.piston.PistonCommon;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.pos.TilePos;
@@ -14,55 +12,50 @@ import org.useless.dragonfly.data.block.BlockModelData;
 import org.useless.dragonfly.models.block.StaticBlockModel;
 
 public class BlockModelGenericPistonHead<T extends BlockLogic> extends BlockModelGenericVeryRotatable<T> {
-    public final @NotNull StaticBlockModel sticky;
-    public final @NotNull StaticBlockModel steel;
-    public final @NotNull StaticBlockModel baseHalf;
-    public final @NotNull StaticBlockModel stickyHalf;
-    public final @NotNull StaticBlockModel steelHalf;
-    public BlockModelGenericPistonHead(@NotNull Block<T> block, @NotNull BlockModelData piston, @NotNull BlockModelData sticky, @NotNull BlockModelData steel, @NotNull BlockModelData pistonHalf, @NotNull BlockModelData stickyHalf, @NotNull BlockModelData steelHalf) {
+
+    public final @NotNull StaticBlockModel[] normal;
+    public final @NotNull StaticBlockModel[] schort;
+    // // it seems like the short versions are good enough for hiding the shaft while extending
+    // // should we delete the block model assets as well?
+    // public final @NotNull StaticBlockModel[] half;
+
+    public BlockModelGenericPistonHead(
+        @NotNull Block<T> block, 
+        @NotNull BlockModelData piston, @NotNull BlockModelData sticky, @NotNull BlockModelData steel, 
+        // @NotNull BlockModelData pistonHalf, @NotNull BlockModelData stickyHalf, @NotNull BlockModelData steelHalf,
+        @NotNull BlockModelData pistonShort, @NotNull BlockModelData stickyShort, @NotNull BlockModelData steelShort
+    ) {
         super(block, piston);
-        this.sticky = sticky.asModel();
-        this.steel = steel.asModel();
-        this.baseHalf = pistonHalf.asModel();
-        this.stickyHalf = stickyHalf.asModel();
-        this.steelHalf = steelHalf.asModel();
+        this.normal = new StaticBlockModel[] { piston.asModel(), sticky.asModel(), steel.asModel() };
+        // this.half = new StaticBlockModel[] { pistonHalf.asModel(), stickyHalf.asModel(), steelHalf.asModel() };
+        this.schort = new StaticBlockModel[] { pistonShort.asModel(), stickyShort.asModel(), steelShort.asModel() };
     }
+
     public void renderPistonHeadNoCulling(@NotNull TessellatorGeneral tessellator, @NotNull WorldSource worldSource, int meta, @NotNull TilePos tilePos, boolean flag) {
-        var model = switch (BlockLogicPistonHead.getPistonType(meta)) {
-            case BlockLogicPistonHead.TYPE_STICKY -> flag ? this.sticky : this.stickyHalf;
-            case BlockLogicPistonHead.TYPE_STEEL -> flag ? this.steel : this.steelHalf;
-            default -> flag ? this.staticModel : this.baseHalf;
-        };
-        final Direction dir = BlockLogicVeryRotatable.metaToDirection(worldSource.getBlockData(tilePos));
+        final var type = PistonCommon.TYPE.get(meta);
+        final var model = (flag) ? normal[type] : schort[type];
+
+        final var dir = Direction.fromId(PistonCommon.DIRECTION.get(meta));
+        final int rx, ry, rz;
         switch (dir) {
-            case UP -> {
-                model.renderAttached(this, tessellator, worldSource, tilePos, 1, 0, 0, 0, 0, 0, false, false, null);
-            }
-            case DOWN -> {
-                model.renderAttached(this, tessellator, worldSource, tilePos, -1, 0, 0, 0, 0, 0, false, false, null);
-            }
-            case NORTH -> {
-                model.renderAttached(this, tessellator, worldSource, tilePos, 0, 0, 0, 0, 0, 0, false, false, null);
-            }
-            case SOUTH -> {
-                model.renderAttached(this, tessellator, worldSource, tilePos, 0, 2, 0, 0, 0, 0, false, false, null);
-            }
-            case WEST -> {
-                model.renderAttached(this, tessellator, worldSource, tilePos, 0, 1, 0, 0, 0, 0, false, false, null);
-            }
-            case EAST -> {
-                model.renderAttached(this, tessellator, worldSource, tilePos, 0, 3, 0, 0, 0, 0, false, false, null);
-            }
+            case UP    -> { rx =  1; ry = 0; rz = 0; }
+            case DOWN  -> { rx = -1; ry = 0; rz = 0; }
+            case NORTH -> { rx =  0; ry = 0; rz = 0; }
+            case SOUTH -> { rx =  0; ry = 2; rz = 0; }
+            case WEST  -> { rx =  0; ry = 1; rz = 0; }
+            case EAST  -> { rx =  0; ry = 3; rz = 0; }
+            default -> { return; }
         }
-    }
 
+        model.renderAttached(this, tessellator, worldSource, tilePos, rx, ry, rz, 0, 0, 0, false, false, null);
+    }
 
     @Override
     public @NotNull StaticBlockModel getModelFromData(int data) {
-        return switch (BlockLogicPistonHead.getPistonType(data)) {
-            case BlockLogicPistonHead.TYPE_STICKY -> this.sticky;
-            case BlockLogicPistonHead.TYPE_STEEL -> this.steel;
-            default -> this.staticModel;
-        };
+        int type = PistonCommon.TYPE.get(data);
+        if (type >= 3) type = 0;
+        return PistonCommon.IS_DETACHED.bool(data)
+            ? schort[type]
+            : normal[type];
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericRope.java b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericRope.java
index 86d6f3407..44b83b468 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericRope.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericRope.java
@@ -27,8 +27,7 @@ public class BlockModelGenericRope<T extends BlockLogic> extends BlockModelGener
 
     @Override
     public boolean renderAttached(@NotNull TessellatorGeneral tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos, boolean cullFaces, @Nullable IconCoordinate overrideTexture) {
-        Block<?> below = worldSource.getBlockType(tilePos.down(new TilePos()));
-        boolean hasFloor = below != null && below.canPlaceOnSurface();
+        boolean hasFloor = worldSource.isBlockOpaqueCube(tilePos.down(new TilePos()));
         boolean hasBlockNegX = canConnect(worldSource, tilePos, Direction.WEST);
         boolean hasBlockPosX = canConnect(worldSource, tilePos, Direction.EAST);
         boolean hasBlockNegY = canConnect(worldSource, tilePos, Direction.DOWN) || hasFloor;
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericTimer.java b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericTimer.java
new file mode 100644
index 000000000..c063da90f
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericTimer.java
@@ -0,0 +1,38 @@
+package net.minecraft.client.render.block.model.generic;
+
+import net.minecraft.client.render.block.model.BlockModelDispatcher;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogicRepeater;
+import net.minecraft.core.block.BlockLogicTimer;
+import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePosc;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+import org.useless.dragonfly.models.block.StaticBlockModel;
+
+public class BlockModelGenericTimer<T extends BlockLogicTimer> extends BlockModelGeneric<T> {
+    public final @NotNull StaticBlockModel[] modelsA = new StaticBlockModel[4];
+    public final @NotNull StaticBlockModel[] modelsB = new StaticBlockModel[4];
+    public BlockModelGenericTimer(@NotNull Block<T> block) {
+        super(block, BlockModelDispatcher.loadDataModel("minecraft:block/timer/0_a"));
+        for (int i = 0; i < 4; i++) {
+            this.modelsA[i] = BlockModelDispatcher.loadDataModel("minecraft:block/timer/" + i + "_a").asModel();
+            this.modelsB[i] = BlockModelDispatcher.loadDataModel("minecraft:block/timer/" + i + "_b").asModel();
+        }
+    }
+
+    @Override
+    public boolean renderAttached(@NotNull TessellatorGeneral tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos, boolean cullFaces, @Nullable IconCoordinate overrideTexture) {
+        final int meta = worldSource.getBlockData(tilePos);
+        final int axis = meta & BlockLogicTimer.MASK_AXIS;
+        final int output = meta & BlockLogicTimer.MASK_OUTPUT;
+        final int tickDelay = meta & BlockLogicTimer.MASK_TICK_DELAY;
+
+        final @NotNull StaticBlockModel[] modelSet = (output == BlockLogicTimer.OUTPUT_A) ? this.modelsB : this.modelsA;
+        final int rotY = axis == BlockLogicTimer.AXIS_WEST_EAST ? 0 : 1;
+
+        return (modelSet[tickDelay >> 2]).renderAttached(this, tessellator, worldSource, tilePos, 0, rotY, 0, 0, 0, 0, false, cullFaces, overrideTexture);
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelDispatcher.java b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelDispatcher.java
index 0621b6019..a7c79b435 100644
--- a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelDispatcher.java
+++ b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelDispatcher.java
@@ -287,6 +287,8 @@ public class ItemModelDispatcher extends Dispatcher<Item, ItemModel> {
         addDispatch(new ItemModelMap(Items.MAP, "minecraft"));
         addDispatch(new ItemModelStandard(Items.TOOL_SHEARS, "minecraft"));
 
+        addDispatch(new ItemModelStandard(Items.TIMER, "minecraft"));
+
         addDispatch(new ItemModelStandard(Items.NETHERCOAL, "minecraft").setFullBright());
 
         addDispatch(new ItemModelStandard(Items.ARMOR_HELMET_STEEL, "minecraft"));
diff --git a/game/client/src/main/java/net/minecraft/client/render/particle/Particle.java b/game/client/src/main/java/net/minecraft/client/render/particle/Particle.java
index cf6ec065b..66f7294e6 100644
--- a/game/client/src/main/java/net/minecraft/client/render/particle/Particle.java
+++ b/game/client/src/main/java/net/minecraft/client/render/particle/Particle.java
@@ -150,7 +150,7 @@ public class Particle {
             switch (hitTile.side) {
                 case EAST:
                 case WEST: {
-                    this.x = hitTile.location.x() + hitTile.side.getOffsetX() * 0.1d * this.size;
+                    this.x = hitTile.location.x() + hitTile.side.offsetX() * 0.1d * this.size;
                     this.y += yd;
                     this.z += zd;
                     this.xd = 0;
@@ -160,7 +160,7 @@ public class Particle {
                     this.onGround = true;
                 case BOTTOM: {
                     this.x += xd;
-                    this.y = hitTile.location.y() + hitTile.side.getOffsetY() * 0.1d * this.size;
+                    this.y = hitTile.location.y() + hitTile.side.offsetY() * 0.1d * this.size;
                     this.z += zd;
                     this.yd = 0;
                     break;
@@ -169,7 +169,7 @@ public class Particle {
                 case NORTH: {
                     this.x += xd;
                     this.y += yd;
-                    this.z = hitTile.location.z() + hitTile.side.getOffsetZ() * 0.1d * this.size;
+                    this.z = hitTile.location.z() + hitTile.side.offsetZ() * 0.1d * this.size;
                     this.zd = 0;
                     break;
                 }
@@ -240,7 +240,7 @@ public class Particle {
                 if (tMin < maxT) {
                     return new HitResult.Tile(
                         tilePos,
-                        direction.getSide(),
+                        direction.side(),
                         new Vector3d(ray.oX + tMin * ray.dX, ray.oY + tMin * ray.dY, ray.oZ + tMin * ray.dZ));
                 }
             }
diff --git a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleDispatcher.java b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleDispatcher.java
index d67c0d5ca..d1a1dbea5 100644
--- a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleDispatcher.java
+++ b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleDispatcher.java
@@ -253,7 +253,7 @@ public final class ParticleDispatcher extends Dispatcher<String, ParticleEntry>
             public Particle newParticle(@NotNull World world, double x, double y, double z, double motionX, double motionY, double motionZ, int data) {
                 float pitch = 0;
                 float yaw = 0;
-                switch (Direction.getDirectionById(data)) {
+                switch (Direction.fromId(data)) {
                     case DOWN -> {
                         pitch = 0.0f;
                         yaw = 0.0f;
diff --git a/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererMovingPiston.java b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererMovingPiston.java
index 496689bb9..c5b41a1ba 100644
--- a/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererMovingPiston.java
+++ b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererMovingPiston.java
@@ -15,7 +15,6 @@ import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.entity.TileEntity;
-import net.minecraft.core.block.piston.BlockLogicPistonBaseSteel;
 import net.minecraft.core.block.piston.BlockLogicPistonHead;
 import net.minecraft.core.block.piston.TileEntityMovingPistonBlock;
 import net.minecraft.core.world.BlocksContainer;
@@ -33,8 +32,8 @@ public class TileEntityRendererMovingPiston extends TileEntityRenderer<TileEntit
     @Override
     public void doRender(TessellatorGeneral tessellator, TileEntityMovingPistonBlock tileEntity, double x, double y, double z,
                          float partialTick) {
-        Block<?> block = tileEntity.getMovedBlock();
-        if (tileEntity.getProgress(partialTick) < 1.0F) {
+        Block<?> block = tileEntity.movingBlock();
+        if (tileEntity.progress(partialTick) < 1.0F) {
             if (this.container == null || this.container.world != tileEntity.worldObj) {
                 this.container = new BlocksContainer(tileEntity.worldObj);
             }
@@ -45,20 +44,18 @@ public class TileEntityRendererMovingPiston extends TileEntityRenderer<TileEntit
             GLRenderer.enableState(State.BLEND);
             GLRenderer.disableState(State.CULL_FACE);
             tessellator.startDrawingQuads();
-            tessellator.setTranslation(((float) x - (float) tileEntity.tilePos.x) + tileEntity.getXOff(partialTick), ((float) y - (float) tileEntity.tilePos.y) + tileEntity.getYOff(partialTick), ((float) z - (float) tileEntity.tilePos.z) + tileEntity.getZOff(partialTick));
-            if (Block.hasLogicClass(block, BlockLogicPistonHead.class) && tileEntity.getProgress(partialTick) < 0.5F) {
+            tessellator.setTranslation(((float) x - (float) tileEntity.tilePos.x) + tileEntity.xOffset(partialTick), ((float) y - (float) tileEntity.tilePos.y) + tileEntity.yOffset(partialTick), ((float) z - (float) tileEntity.tilePos.z) + tileEntity.zOffset(partialTick));
+            if (Block.hasLogicClass(block, BlockLogicPistonHead.class) && tileEntity.progress(partialTick) < 0.5F) {
                 ((BlockModelGenericPistonHead<?>) BlockModelDispatcher.getInstance().getDispatch(block)).renderPistonHeadNoCulling(tessellator, tileEntity.worldObj, tileEntity.getBlockMeta(), tileEntPos, false);
             } else if (tileEntity.isSourcePiston() && !tileEntity.isExtending()) {
-                BlockModelGenericPiston<?> pistonBase = (BlockModelGenericPiston<?>) BlockModelDispatcher.getInstance().getDispatch(block);
-                if (Block.hasLogicClass(block, BlockLogicPistonBaseSteel.class)) { // Todo remove this terrible hardcoded render code
-                    ((BlockModelGenericPistonHead<?>) BlockModelDispatcher.getInstance().getDispatch(Blocks.PISTON_HEAD_STEEL)).renderPistonHeadNoCulling(tessellator, tileEntity.worldObj, BlockLogicPistonHead.TYPE_STEEL << 3, tileEntPos, tileEntity.getProgress(partialTick) < 0.5F);
-                } else {
-                    ((BlockModelGenericPistonHead<?>) BlockModelDispatcher.getInstance().getDispatch(Blocks.PISTON_HEAD)).renderPistonHeadNoCulling(tessellator, tileEntity.worldObj, tileEntity.getBlockMeta(), tileEntPos, tileEntity.getProgress(partialTick) < 0.5F);
-                }
+                ((BlockModelGenericPistonHead<?>) BlockModelDispatcher.getInstance().getDispatch(Blocks.PISTON_HEAD)).renderPistonHeadNoCulling(tessellator, tileEntity.worldObj, tileEntity.getBlockMeta(), tileEntPos, tileEntity.progress(partialTick) < 0.5F);
                 tessellator.setTranslation((float) x - (float) tileEntity.tilePos.x, (float) y - (float) tileEntity.tilePos.y, (float) z - (float) tileEntity.tilePos.z);
-                pistonBase.renderHeadless(tessellator, tileEntity.worldObj, tileEntPos);
+                ((BlockModelGenericPiston<?>) BlockModelDispatcher.getInstance().getDispatch(block)).renderHeadless(tessellator, tileEntity.worldObj, tileEntPos);
             } else {
-                this.container.setBlock(tileEntity.tilePos.x, tileEntity.tilePos.y, tileEntity.tilePos.z, block.id(), tileEntity.getMovedData(), tileEntity.getMovedEntity());
+                this.container.setBlockTypeData(tileEntity.tilePos, block, tileEntity.movingBlockData());
+                if (tileEntity.movingTileEntity() != null) {
+                    this.container.setTileEntity(tileEntity.tilePos, tileEntity.movingTileEntity());
+                }
                 BlockModelDispatcher.getInstance().getDispatch(block).renderNoCulling(tessellator, this.container, tileEntPos);
                 this.container.setLightReferenceEntity(null);
                 this.container.clear();
@@ -66,11 +63,11 @@ public class TileEntityRendererMovingPiston extends TileEntityRenderer<TileEntit
             tessellator.setTranslation(0.0D, 0.0D, 0.0D);
             tessellator.draw();
 
-            TileEntity movedEntity = tileEntity.getMovedEntity();
+            TileEntity movedEntity = tileEntity.movingTileEntity();
             TileEntityRenderer<TileEntity> renderer = TileEntityRenderDispatcher.instance.getRenderer(movedEntity);
             if (renderer != null) {
                 GLRenderer.pushFrame();
-                GLRenderer.modelM4f().translate(tileEntity.getXOff(partialTick), tileEntity.getYOff(partialTick), tileEntity.getZOff(partialTick));
+                GLRenderer.modelM4f().translate(tileEntity.xOffset(partialTick), tileEntity.yOffset(partialTick), tileEntity.zOffset(partialTick));
                 renderer.doRender(tessellator, movedEntity, x, y, z, partialTick);
                 GLRenderer.popFrame();
             }
diff --git a/game/client/src/main/java/org/useless/dragonfly/data/block/mojang/CompiledBlockModelMojangData.java b/game/client/src/main/java/org/useless/dragonfly/data/block/mojang/CompiledBlockModelMojangData.java
index 2120bd1c3..e48dcc3c2 100644
--- a/game/client/src/main/java/org/useless/dragonfly/data/block/mojang/CompiledBlockModelMojangData.java
+++ b/game/client/src/main/java/org/useless/dragonfly/data/block/mojang/CompiledBlockModelMojangData.java
@@ -80,12 +80,12 @@ public class CompiledBlockModelMojangData {
 
         this.particleIndices = new int[6];
         if (data.particleIndices != null) {
-            this.particleIndices[Direction.UP.getId()] = data.particleIndices.getOrDefault(Direction.UP, 0);
-            this.particleIndices[Direction.DOWN.getId()] = data.particleIndices.getOrDefault(Direction.DOWN, 0);
-            this.particleIndices[Direction.NORTH.getId()] = data.particleIndices.getOrDefault(Direction.NORTH, 0);
-            this.particleIndices[Direction.SOUTH.getId()] = data.particleIndices.getOrDefault(Direction.SOUTH, 0);
-            this.particleIndices[Direction.WEST.getId()] = data.particleIndices.getOrDefault(Direction.WEST, 0);
-            this.particleIndices[Direction.EAST.getId()] = data.particleIndices.getOrDefault(Direction.EAST, 0);
+            this.particleIndices[Direction.UP.id] = data.particleIndices.getOrDefault(Direction.UP, 0);
+            this.particleIndices[Direction.DOWN.id] = data.particleIndices.getOrDefault(Direction.DOWN, 0);
+            this.particleIndices[Direction.NORTH.id] = data.particleIndices.getOrDefault(Direction.NORTH, 0);
+            this.particleIndices[Direction.SOUTH.id] = data.particleIndices.getOrDefault(Direction.SOUTH, 0);
+            this.particleIndices[Direction.WEST.id] = data.particleIndices.getOrDefault(Direction.WEST, 0);
+            this.particleIndices[Direction.EAST.id] = data.particleIndices.getOrDefault(Direction.EAST, 0);
         }
 
         this.renderLayer = data.renderLayer == null ? 0 : data.renderLayer;
diff --git a/game/client/src/main/java/org/useless/dragonfly/data/entity/mojang/Cube.java b/game/client/src/main/java/org/useless/dragonfly/data/entity/mojang/Cube.java
index 813b609a0..2463611a9 100644
--- a/game/client/src/main/java/org/useless/dragonfly/data/entity/mojang/Cube.java
+++ b/game/client/src/main/java/org/useless/dragonfly/data/entity/mojang/Cube.java
@@ -75,17 +75,17 @@ public class Cube {
             final double sizeX = this.size[0];
             final double sizeY = this.size[1];
             final double sizeZ = this.size[2];
-            this.faces[Direction.UP.getId()] = new Face.Builder(u + sizeZ, v, sizeX, sizeZ);
-            this.faces[Direction.DOWN.getId()] = new Face.Builder(u + sizeX + sizeZ, v + sizeZ, sizeX, -sizeZ);
-            this.faces[Direction.NORTH.getId()] = new Face.Builder(u + sizeZ, v + sizeZ, sizeX, sizeY);
-            this.faces[Direction.SOUTH.getId()] = new Face.Builder(u + (sizeZ * 2) + sizeX, v + sizeZ, sizeX, sizeY);
-            this.faces[Direction.EAST.getId()] = new Face.Builder(u, v + sizeZ, sizeZ, sizeY);
-            this.faces[Direction.WEST.getId()] = new Face.Builder(u + sizeZ + sizeX, v + sizeZ, sizeZ, sizeY);
+            this.faces[Direction.UP.id] = new Face.Builder(u + sizeZ, v, sizeX, sizeZ);
+            this.faces[Direction.DOWN.id] = new Face.Builder(u + sizeX + sizeZ, v + sizeZ, sizeX, -sizeZ);
+            this.faces[Direction.NORTH.id] = new Face.Builder(u + sizeZ, v + sizeZ, sizeX, sizeY);
+            this.faces[Direction.SOUTH.id] = new Face.Builder(u + (sizeZ * 2) + sizeX, v + sizeZ, sizeX, sizeY);
+            this.faces[Direction.EAST.id] = new Face.Builder(u, v + sizeZ, sizeZ, sizeY);
+            this.faces[Direction.WEST.id] = new Face.Builder(u + sizeZ + sizeX, v + sizeZ, sizeZ, sizeY);
             return this;
         }
 
         public @NotNull Builder setFace(final @NotNull Direction direction, final @Nullable Face.Builder builder) {
-            this.faces[direction.getId()] = builder;
+            this.faces[direction.id] = builder;
             return this;
         }
 
@@ -111,9 +111,9 @@ public class Cube {
         }
 
         protected void mirror() {
-            final Face.Builder west = this.faces[Direction.WEST.getId()];
-            this.faces[Direction.WEST.getId()] = this.faces[Direction.EAST.getId()];
-            this.faces[Direction.EAST.getId()] = west;
+            final Face.Builder west = this.faces[Direction.WEST.id];
+            this.faces[Direction.WEST.id] = this.faces[Direction.EAST.id];
+            this.faces[Direction.EAST.id] = west;
             for (final Face.Builder builder : this.faces) {
                 if (builder == null) continue;
                 builder.setMirror();
